class DataParser{

  
  private String   dataToLoad = "Newcastle_London";
  private String[] exceptionList = {"EC59JL","gnerwifi","EC59LM",")	BSS	("};

  private String[] dataLoaded;
  private String[] goodESSID;
  private String[] uniqueESSID;
  
  DataParser() { 
    println("DataParser!!!"); 
  } 


  public void loadData(){
    dataLoaded = loadStrings(dataToLoad+".txt");
    println("there are " + dataLoaded.length + " Entries");
    goodESSID = new String[dataLoaded.length];
    uniqueESSID = new String[dataLoaded.length];
    filterSSIDs(0, dataLoaded.length, exceptionList);
  }



  // get rid of unwanted essis. 
  // Usefull when travelling on a train 
  // with a wireless network.
  private void filterSSIDs(int startPoint, int endPoint, String[] anExeptionList){
    int goodIndex = 0;
    //loop through all our data
    for (int i = startPoint; i < endPoint; i++){
      
      boolean error = false;
      String currMac = trim(extractData(dataLoaded[i], MAC_ID));
      for (int e = 0 ; e < anExeptionList.length; e++){
        String tempException = trim(anExeptionList[e]);
        String tempEssid     = trim(extractData(dataLoaded[i], SSID_ID));
        if(tempException.equals(tempEssid)) error = true;
      }
      
      // check for allready processed essid
      //if(goodIndex > 0)
      if(belongToArray(uniqueESSID, currMac, goodIndex)) error = true;
      
      if(!error) {
        println("bingo! : "+(extractData(dataLoaded[i], SSID_ID)));
        println("-----------------------------------");
        goodESSID[goodIndex] = dataLoaded[i];
        uniqueESSID[goodIndex] = currMac;
        goodIndex ++;
      }
    }
    //get rid of null entries    
    goodESSID = trimNull(goodESSID);
    //save the filtered results 
    saveData(goodESSID);
  }


  // save back a txt file with name corresponding to raw file.
  // we record the day and month too in the naming convention.
  private void saveData(String[] aStringArray){
    saveStrings("records/"+dataToLoad+"_"+String.valueOf(day())+"_"+String.valueOf(month())+"_processed.txt", aStringArray);
  }



  
  // -> String record
  // -> int Id to look for and return
  // <- string corresponding to id
  private String extractData(String inData, int dataID){
    trim(inData);
    String tempData[] = split(inData, "  ");
    return tempData[dataID];
  }

  
  // -> string array
  // <- boolean is string found in array
  private boolean belongToArray(String[] inArray, String inValue, int inGoodIndex){
    for (int i = 0 ; i < inGoodIndex; i++){
      //if(inArray[i] == inValue){
      //println("inArray["+i+"]"+inArray[i]+" <==> "+inValue);
      if(trim(inArray[i]).equals(trim(inValue)))return true;
    }
    return false;
  }


  //Trim null values of string array
  private String[] trimNull(String[] aStringArray){

    int lengthGoodData = 0;
    String[] tempArr = {
    };

    //find number of non null data
    for (int i = 0; i < aStringArray.length; i++){
      if (aStringArray[i] != null)lengthGoodData++;
    }

    //redefine the proper lenght of our new array
    tempArr = new String[lengthGoodData];

    //repopulate new array
    for (int i = 0; i < aStringArray.length; i++){
      if (aStringArray[i] != null)tempArr[i] = aStringArray[i];
    }
    
    println("Number of Good Data : "+lengthGoodData);
    //and return it to sender
    return tempArr;
  }
}
