import processing.xml.*;

XMLElement xml;

int ESSID_ID      = 0;
int TIME_ID       = 1;
int BSSID_ID      = 2;
int CHANNEL_ID    = 3;
int ENCRYPTION_ID = 4;
int MAXRATE_ID    = 5;

float totalJourneyTime;


float prevX = 0.0f;
float prevY = 0.0f;
float barHeight = 0.0f;
int incrbar = 10;

String FRANCE_VESCEMONT_BELFORT = "Kismet-Jun-29-2007-4.xml";
PFont clean;

DataLookNize  datalooknize;

void setup(){
  
  size(1024,600);
  smooth();
  
  //clean = loadFont("dialoginput-9.vlw");
  clean = loadFont("sansserif-9.vlw");
  
  textFont(clean, 9);

  totalJourneyTime = 0;

  xml = new XMLElement(this, FRANCE_VESCEMONT_BELFORT);
  parseXML();
}


void parseXML(){

  background(0);
  
  XMLElement nodes = xml.getChild(0); // get our nodes
  XMLElement[] nodesData = xml.getChildren();

  float startJourneyTime =  getSeconds(nodesData[0].getStringAttribute("first-time"));
  float endJourneyTime   = getSeconds(nodesData[nodesData.length-1].getStringAttribute("first-time"));

  totalJourneyTime = endJourneyTime - startJourneyTime;
  println("totalJourneyTime : "+totalJourneyTime);

  for (int i = 0; i < nodesData.length; i++) {
    String essid = nodesData[i].getChild(0).getContent();
    String time = nodesData[i].getStringAttribute("first-time");
    String bssid = nodesData[i].getChild(1).getContent();
    String channel = nodesData[i].getChild(2).getContent();
    String maxrate = nodesData[i].getChild(3).getContent();
    String encryption = nodesData[i].getChild(5).getContent();    //note : some have apparentlly several encrption mode in the xml format
    //println("essid:"+essid+"  time:"+time+" bssid:"+bssid+" channel:"+channel+" encryption:"+encryption+" maxrate:"+maxrate);
    float relativeJourneyTime = getSeconds(time)-startJourneyTime;
    doEssid(i, essid, relativeJourneyTime, bssid, channel, encryption, maxrate);
  }


  println("M0000oogaaaaaaaaaaaa! "+totalJourneyTime/60+" minutes to get "+nodesData.length+" wireless nodes recorded!");
  save("looknize-"+random(1234)+".png");
  println("_______ img saved! _______");
}




void doEssid(int id, String inEssid, float inTime, String inBssid, String inChannel, String inEncryption, String inMaxrate){
  
  //float posY = sin(tick)*((height-200)/2)+(height)/2;
  float posY = (height)/2;
  float posX = (inTime*(width-200))/totalJourneyTime+100;
  
  stroke(0);
  
  if(posX > 100) line(prevX, prevY, posX, posY);
  
  barHeight -= incrbar;
  if(abs(barHeight) > height/2-100) incrbar = incrbar*-1;
  
  //barHeight = -float(inMaxrate;
  //println(inMaxrate);
  
  /* VERTICAL LINE */
  if(inEncryption.equals("WEP")){
    stroke(255,0,0);
  }else if(inEncryption.equals("WPA")){
    stroke(0,0,255);
  }else if(inEncryption.equals("None") || trim(inEncryption).equals("") || trim(inEncryption).equals("0")){
   stroke(200,255,0); 
  }else{
   println("some encryption colors aren't mapped like this one dude : "+inEncryption); 
  }
  //line(posX,posY,posX,posY+barHeight);
  noFill();
  ellipse(posX,posY+barHeight,barHeight/2,barHeight/2);
  //ellipse(posX,posY+barHeight,float(inChannel),float(inChannel));
  
  ellipse(posX,posY+barHeight, 2, 2);
  
  /* TEXT */
  pushMatrix();
  translate(posX, posY);
  
  stroke(255);
  line(0,0+2, 0, -4);
  
  noStroke();
  fill(0);
  //ellipse(0, 0, 2, 2);
  //text(inEssid.toLowerCase(), 7,barHeight);
  //text(id, 0-3,barHeight-5);
  popMatrix();
    
  prevX = posX;
  prevY = posY;

}



// get time as hh:mm:ss return int of total seconds
int getSeconds(String inTimeStamp){  
  inTimeStamp = split(inTimeStamp)[3];
  int h =  int(split(inTimeStamp,":")[0])*3600;
  int m =  int(split(inTimeStamp,":")[1])*60;
  int s =  int(split(inTimeStamp,":")[2]);
  int totalSec = h+m+s;
  return totalSec;
}
